=== debian/changelog ===
drp (1.0-2) UNRELEASED; urgency=medium

  * new version with larger number of channels; fix in drp script

 -- Michael Olberg <michael.olberg@chalmers.se>  Fri, 02 Sep 2016 13:59:34 +0200

drp (1.0-1) unstable; urgency=low

  * Initial Release.

 -- Michael Olberg <michael.olberg@chalmers.se>  Fri, 25 Aug 2016 15:23:15 +0200
