=== debian/control ===
Source: drp
Section: science
Priority: optional
Maintainer: Michael Olberg <michael.olberg@chalmers.se>
Build-Depends: debhelper (>= 7), libx11-dev
Standards-Version: 3.9.5

Package: drp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: data reduction of radioastronomical spectral line data
 A program to reduce radio-astronomical spectral line data. Support 
 for various input formats, e.g. FITS.
 .
 The program uses plain X11 as the graphical user interface toolkit.
